/*
 * generated by Xtext 2.32.0
 */
package org.eclipse.gef.dot.internal.language.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.gef.dot.internal.language.point.Point;
import org.eclipse.gef.dot.internal.language.point.PointPackage;
import org.eclipse.gef.dot.internal.language.services.DotSplineTypeGrammarAccess;
import org.eclipse.gef.dot.internal.language.splinetype.Spline;
import org.eclipse.gef.dot.internal.language.splinetype.SplineType;
import org.eclipse.gef.dot.internal.language.splinetype.SplinetypePackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;

@SuppressWarnings("all")
public class DotSplineTypeSemanticSequencer extends DotPointSemanticSequencer {

	@Inject
	private DotSplineTypeGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == PointPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case PointPackage.POINT:
				sequence_Point(context, (Point) semanticObject); 
				return; 
			}
		else if (epackage == SplinetypePackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case SplinetypePackage.SPLINE:
				sequence_Spline(context, (Spline) semanticObject); 
				return; 
			case SplinetypePackage.SPLINE_TYPE:
				sequence_SplineType(context, (SplineType) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * <pre>
	 * Contexts:
	 *     SplineType returns SplineType
	 *
	 * Constraint:
	 *     (splines+=Spline splines+=Spline*)
	 * </pre>
	 */
	protected void sequence_SplineType(ISerializationContext context, SplineType semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Spline returns Spline
	 *
	 * Constraint:
	 *     (startp=Point? endp=Point? controlPoints+=Point (controlPoints+=Point controlPoints+=Point controlPoints+=Point)+)
	 * </pre>
	 */
	protected void sequence_Spline(ISerializationContext context, Spline semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
